﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Windows.Input;

namespace ChartError.ViewModel {

  public class ChartViewModel : BaseObject {

    private ObservableCollection<ChartData> _ChartDataList;

    public ChartViewModel() {
      _ChartDataList = ChartData.GetKeys();
    }

    public ObservableCollection<ChartData> ChartDataList {
      get { return _ChartDataList; }
      set { SetProperty<ObservableCollection<ChartData>>("ChartDatas", value, ref _ChartDataList); }
    }

  }

  public class ChartData : BaseObject {

    private int _Id;
    private string _Name;
    private double _Value;

    public ChartData(int id, string name, double value) {
      _Id = id;
      _Name = name;
      _Value = value;
    }

    public int Id {
      get { return _Id; }
    }

    public string Name {
      get { return _Name; }
      set { SetProperty<string>("Name", value, ref _Name); }
    }

    public double Value {
      get { return _Value; }
      set { SetProperty<double>("Value", value, ref _Value); }
    }

    public void NotifyEntityChanged() {
      this.OnPropertyChanged(null);
    }

    public static ObservableCollection<ChartData> GetKeys() {
      var result = new ObservableCollection<ChartData>();
      result.Add(new ChartData(1, "Item 1", 4));
      result.Add(new ChartData(2, "Item 2", 5));
      result.Add(new ChartData(3, "Item 3", 2));
      result.Add(new ChartData(4, "Item 4", 9));
      result.Add(new ChartData(5, "Item 5", 1));
      result.Add(new ChartData(6, "Item 6", 2));
      result.Add(new ChartData(7, "Item 7", 10));
      result.Add(new ChartData(8, "Item 8", 4));
      result.Add(new ChartData(9, "Item 9", 8));

      return result;
    }

  }

}
